## dolfin 0.9.7

=== SConstruct ===
# -*- coding: utf-8 -*-

import os, os.path, sys
import warnings
import pickle

from distutils import sysconfig

# Make sure that we have a good scons-version
EnsureSConsVersion(0, 98, 5)

# Import the local 'scons'
sys.path.insert(0, os.path.abspath(os.path.join("scons", "simula-scons")))
print os.path.abspath(os.path.join("scons", "simula-scons"))
import simula_scons as scons

# Import local exceptions
from simula_scons.Errors import PkgconfigError, PkgconfigMissing

# Create a SCons Environment based on the main os environment
env = scons.ExtendedEnvironment(ENV=os.environ)

# Add ARGUMENTS to SCons environment
env.ARGUMENTS = ARGUMENTS

# Set a projectname. Used in some places, like pkg-config generator
env["projectname"] = "dolfin"

# Set version
env["PACKAGE_VERSION"] = "0.9.7"

scons.setDefaultEnv(env)

# Specify a file where SCons store file signatures, used to figure out what is
# changed. We store it in the 'scons' subdirectory to avoid mixing signatures
# with the files in this project.
project_sconsignfile = os.path.abspath(os.path.join("scons", ".sconsign"))
env.SConsignFile(project_sconsignfile)

# -----------------------------------------------------------------------------
# Command line option handling
# -----------------------------------------------------------------------------

DefaultPackages = ""

if env["PLATFORM"].startswith("win"):
  default_prefix = r"c:\local"
else:
  default_prefix = os.path.join(os.path.sep,"usr","local")

# Set a global path_validator
path_validator = PathVariable.PathAccept

# Build the commandline options for SCons:
options = [
    # configurable options for installation:
    PathVariable("prefix", "Installation prefix", default_prefix,
                 path_validator),
    PathVariable("DESTDIR",
                 "Prepend DESTDIR to each installed target file", None,
                 path_validator),
    PathVariable("binDir", "Binary installation directory",
                 os.path.join("$prefix","bin"), path_validator),
    PathVariable("manDir", "Manual page installation directory",
                 os.path.join("$prefix", "share", "man"), path_validator),
    PathVariable("libDir", "Library installation directory",
                 os.path.join("$prefix","lib"), path_validator),
    PathVariable("pkgConfDir", "Directory for installation of pkg-config files",
                 os.path.join("$prefix","lib","pkgconfig"), path_validator),
    PathVariable("includeDir", "C/C++ header installation directory",
                 os.path.join("$prefix","include"), path_validator),
    PathVariable("pythonModuleDir", "Python module installation directory",
                 scons.defaultPythonLib(prefix="$prefix"),
                 path_validator),
    PathVariable("pythonExtDir", "Python extension module installation directory",
                 scons.defaultPythonLib(prefix="$prefix", plat_specific=True),
                 path_validator),
    # configurable options for how we want to build:
    BoolVariable("enableDebug", "Build with debug information", 1),
    BoolVariable("enableExtraDebug", "Build with extra debug information (no -O2)", 0),
    BoolVariable("enableDebugUblas", "Add some extra Ublas debug information", 0),
    BoolVariable("enableOptimize", "Compile with optimization", 0),
    BoolVariable("enableDocs", "Build documentation", 0),
    BoolVariable("enableDemos", "Build demos", 0),
    BoolVariable("enableTests", "Build tests", 0),
    BoolVariable("enableBenchmarks", "Build benchmark programs", 0),
    BoolVariable("enableCodeCoverage", "Enable code coverage", 0),
    BoolVariable("enableResolveCompiler", "Run tests to verify compiler", 1),
    # Enable or disable external packages.
    # These will also be listed in scons.cfg files, but if they are
    # disabled here, that will override scons.cfg. Remark that unless the
    # module is listed as OptDependencies in scons.cfg, the whole module
    # will be turned off.
    BoolVariable("enableMpi", "Compile with support for MPI", "yes"),
    BoolVariable("enablePetsc", "Compile with support for PETSc linear algebra", "yes"),
    BoolVariable("enableSlepc", "Compile with support for SLEPc", "yes"),
    BoolVariable("enableScotch", "Compile with support for SCOTCH graph partitioning", "yes"),
    BoolVariable("enableUmfpack", "Compile with support for UMFPACK", "yes"),
    BoolVariable("enableTrilinos", "Compile with support for Trilinos", "yes"),
    BoolVariable("enableCholmod", "Compile with support for CHOLMOD", "yes"),
    BoolVariable("enableMtl4", "Compile with support for MTL4", "yes"),
    BoolVariable("enableParmetis", "Compile with support for ParMETIS", "yes"),
    BoolVariable("enableGmp", "Compile with support for GMP", "no"),
    BoolVariable("enableZlib", "Compile with support for zlib", "yes"),
    BoolVariable("enableCgal", "Compile with support for CGAL", "yes"),
    BoolVariable("enableLapack", "Compile with support for LAPACK", "yes"),
    BoolVariable("enablePython", "Compile the Python wrappers", "yes"),
    BoolVariable("enablePydolfin", "Compile the Python wrappers of DOLFIN *deprecated*", "yes"),
    # some of the above may need extra options (like petscDir), should we
    # try to get that from pkg-config?
    # It may be neccessary to specify the installation path to the above packages.
    # One can either use the options below (with<Package>Dir) or define the
    # <PACKAGE>_DIR environment variable.
    PathVariable("withPetscDir", "Specify path to PETSc", None, path_validator),
    PathVariable("withSlepcDir", "Specify path to SLEPc", None, path_validator),
    PathVariable("withScotchDir", "Specify path to SCOTCH", None, path_validator),
    PathVariable("withUmfpackDir", "Specify path to UMFPACK", None, path_validator),
    PathVariable("withTrilinosDir", "Specify path to Trilinos", None, path_validator),
    PathVariable("withCholmodDir", "Specify path to CHOLMOD", None, path_validator),
    PathVariable("withMtl4Dir", "Specify path to MTL4", None, path_validator),
    PathVariable("withParmetisDir", "Specify path to ParMETIS", None, path_validator),
    PathVariable("withGmpDir", "Specify path to GMP", None, path_validator),
    PathVariable("withBoostDir", "Specify path to Boost", None, path_validator),
    PathVariable("withLibxml2Dir", "Specify path to libXML2", None, path_validator),
    PathVariable("withZlibDir", "Specify path to zlib", None, path_validator),
    PathVariable("withCgalDir", "Specify path to CGAL", None, path_validator),
    PathVariable("withLapackDir", "Specify path to LAPACK", None, path_validator),
    PathVariable("withBlasDir", "Specify path to BLAS", None, path_validator),
    #
    # a few more options originally from PyCC:
    #BoolVariable("autoFetch", "Automatically fetch datafiles from (password protected) SSH repository", 0),
    BoolVariable("cacheOptions", "Cache command-line options for later invocations", 1),
    BoolVariable("veryClean", "Remove the sconsign file during clean, must be set during regular build", 0),
    # maybe we should do this more cleverly. The default in dolfin now is
    # to use mpicxx if that is available...:
    #("CXX", "Set C++ compiler", scons.defaultCxxCompiler()),
    #("FORTRAN", "Set FORTRAN compiler",scons.defaultFortranCompiler()),
    ("customCxxFlags", "Customize compilation of C++ code", ""),
    ("customLinkFlags", "Customize linking of C++ code", ""),
    #("data", "Parameter to the 'fetch' target: comma-delimited list of directories/files to fetch, \
    #        relative to the `data' directory. An empty value means that everything will be fetched.", ""),
    #("sshUser", "Specify the user for the SSH connection used to retrieve data files", ""),
    #('usePackages','Override or add dependency packages, separate with comma', ""),
    #('customDefaultPackages','Override the default set of packages (%r), separate package names with commas' % (DefaultPackages,)),
    ("SSLOG", "Set Simula scons log file", os.path.join(os.getcwd(),"scons","simula_scons.log")),
    ("withPetscArch", "The architecture PETSc is configured with", None),
    ]


# Option enablePydolfin is now deprecated
if ARGUMENTS.has_key("enablePydolfin"):
  msg = "Option 'enablePydolfin' is deprecated and will be removed in " \
        "the future. Please use the option 'enablePython' instead to " \
        "enable/disable compiling of Python wrappers."
  warnings.warn(msg, DeprecationWarning)
  if not ARGUMENTS.has_key("enablePython"):
    ARGUMENTS["enablePython"] = ARGUMENTS["enablePydolfin"]
  del ARGUMENTS["enablePydolfin"]

config_cache = os.path.join('scons', 'config.cache')
if not "configure" in COMMAND_LINE_TARGETS and not env.GetOption('help'):
  # Try to open the pickled configuration cache under scons/config.cache
  try:
    f = open(config_cache, 'r')
    up = pickle.Unpickler(f)
    env_cache, modules, configuredPackages = up.load()
    for key, value in env_cache.items():
      env[key] = value
  except IOError:
      print """---------------------------------------------------------
No configuration found. Please run

    scons configure

before building DOLFIN. To view a complete list of
available configuration options, run

    scons configure --help or -h

For SCons specific options, run

    scons --help-options or -H

---------------------------------------------------------"""
      Exit(1)

# Set up basic data dicitionary
buildDataHash = {"shlibs": [], "extModules": [], "docs": [], "headers": [],
                 "pythonModules": [], "pythonScripts": [], "pkgconfig": [],
                 "pythonPackageDirs": [], "data": [], "tests": [], "progs": [],
                 "demos": [], "dolfin_header": "", "swigfiles": [],
                 "benchmarks": []}

if "configure" in COMMAND_LINE_TARGETS:
  # This Configure class handles both command-line options (which are merged
  # into the environment) and autoconf-style tests. A special feature is that it
  # remembers configuration parameters (options and results from tests) between
  # invocations so that they are re-used when cleaning after a previous build.
  configure = scons.Configure(env, ARGUMENTS, options)

  # Open log file for writing
  scons.logOpen(env)
  scons.log("=================== %s log ===================" % \
            env["projectname"])
  scons.logDate()

  # Writing the simula_scons used to the log:
  scons.log("Using simula_scons from: %s" % scons.__file__)

  # Notify the user about that options from scons/options.cache are being used:
  if not env.GetOption("clean"):
    try:
      optsCache = os.path.abspath(os.path.join("scons", "options.cache"))
      lines = file(optsCache).readlines()
      if lines:
        print "Using options from %s" % optsCache
      # FIXME: this can be removed when option enablePydolfin is removed
      new_lines = []
      for line in lines:
        if line.startswith("enablePydolfin"):
          if not "enablePython" in lines:
            env["enablePython"] = eval(line.split('=')[1])
            new_lines.append("enablePython = %s\n" % env["enablePython"])
        else:
          new_lines.append(line)
      if new_lines != lines:
        file(optsCache, 'w').writelines(new_lines)
    except IOError, msg:
      pass

  # Set default compiler and linker flags (defining CXXFLAGS/LINKFLAGS
  # will override this)
  env['CXXFLAGS'] = os.environ.get("CXXFLAGS", "-Wall -pipe -ansi")
  env["LINKFLAGS"] = os.environ.get("LINKFLAGS", "")  # FIXME: "" OK as default?

  # Default FORTRAN flags
  #env["SHFORTRANFLAGS"] = "-Wall -pipe -fPIC"

  # If Debug is enabled, add -g:

  if not env["enableDebugUblas"]:
    env.Append(CXXFLAGS=" -BOOST_UBLAS_NDEBUG")

  # if Optimization is requested, use -O3
  if env["enableOptimize"]:
    env.Append(CXXFLAGS=" -O3")
  elif env["enableExtraDebug"]:
    env.Append(CXXFLAGS=" -DDEBUG -g -Werror")
  elif env["enableDebug"]:
    env.Append(CXXFLAGS=" -DDEBUG -g -O2  -Werror")
  else:

=== bench/la/sparse-matrix/SConstruct ===
import os, commands

# Get compiler from pkg-config
compiler = commands.getoutput('pkg-config --variable=compiler dolfin')

# Create a SCons Environment based on the main os environment
env = Environment(ENV=os.environ, CXX=compiler)

# Get compiler flags from pkg-config
env.ParseConfig('pkg-config --cflags --libs dolfin')

# Program name
env.Program('dolfin-la-sparse-matrix', 'main.cpp')

=== bench/la/vector/SConstruct ===
import os, commands

# Get compiler from pkg-config
compiler = commands.getoutput('pkg-config --variable=compiler dolfin')

# Create a SCons Environment based on the main os environment
env = Environment(ENV=os.environ, CXX=compiler)

# Get compiler flags from pkg-config
env.ParseConfig('pkg-config --cflags --libs dolfin')

# Program name
env.Program('dolfin-la-vector', 'main.cpp')

=== bench/mesh/basic/SConstruct ===
import os, commands

# Get compiler from pkg-config
compiler = commands.getoutput('pkg-config --variable=compiler dolfin')

# Create a SCons Environment based on the main os environment
env = Environment(ENV=os.environ, CXX=compiler)

# Get compiler flags from pkg-config
env.ParseConfig('pkg-config --cflags --libs dolfin')

# Program name
env.Program('dolfin-bench-mesh', 'main.cpp')

## dolfin 0.9.8

=== SConstruct ===
--- 
+++ 
@@ -27,7 +27,7 @@
 env["projectname"] = "dolfin"
 
 # Set version
-env["PACKAGE_VERSION"] = "0.9.7"
+env["PACKAGE_VERSION"] = "0.9.8"
 
 scons.setDefaultEnv(env)
 
@@ -105,7 +105,6 @@
     BoolVariable("enableCgal", "Compile with support for CGAL", "yes"),
     BoolVariable("enableLapack", "Compile with support for LAPACK", "yes"),
     BoolVariable("enablePython", "Compile the Python wrappers", "yes"),
-    BoolVariable("enablePydolfin", "Compile the Python wrappers of DOLFIN *deprecated*", "yes"),
     # some of the above may need extra options (like petscDir), should we
     # try to get that from pkg-config?
     # It may be neccessary to specify the installation path to the above packages.
@@ -126,6 +125,7 @@
     PathVariable("withCgalDir", "Specify path to CGAL", None, path_validator),
     PathVariable("withLapackDir", "Specify path to LAPACK", None, path_validator),
     PathVariable("withBlasDir", "Specify path to BLAS", None, path_validator),
+    PathVariable("withArmadilloDir", "Specify path to Armadillo", None, path_validator),
     #
     # a few more options originally from PyCC:
     #BoolVariable("autoFetch", "Automatically fetch datafiles from (password protected) SSH repository", 0),
@@ -144,18 +144,15 @@
     #('customDefaultPackages','Override the default set of packages (%r), separate package names with commas' % (DefaultPackages,)),
     ("SSLOG", "Set Simula scons log file", os.path.join(os.getcwd(),"scons","simula_scons.log")),
     ("withPetscArch", "The architecture PETSc is configured with", None),
+    ("withBlasLapackLib", "Indicate the library(s) containing BLAS and LAPACK", None),
+    ("withMpiCompiler", "Specify the MPI compiler", ""),
     ]
 
-
-# Option enablePydolfin is now deprecated
-if ARGUMENTS.has_key("enablePydolfin"):
-  msg = "Option 'enablePydolfin' is deprecated and will be removed in " \
-        "the future. Please use the option 'enablePython' instead to " \
-        "enable/disable compiling of Python wrappers."
-  warnings.warn(msg, DeprecationWarning)
-  if not ARGUMENTS.has_key("enablePython"):
-    ARGUMENTS["enablePython"] = ARGUMENTS["enablePydolfin"]
-  del ARGUMENTS["enablePydolfin"]
+if ARGUMENTS.has_key("withBlasLapackLib") and \
+       not ARGUMENTS.has_key("withLapackDir"):
+  print "*** When using the withBlasLapackLib option you must also use " \
+        "withLapackDir."
+  Exit(1)
 
 config_cache = os.path.join('scons', 'config.cache')
 if not "configure" in COMMAND_LINE_TARGETS and not env.GetOption('help'):
@@ -214,17 +211,6 @@
       lines = file(optsCache).readlines()
       if lines:
         print "Using options from %s" % optsCache
-      # FIXME: this can be removed when option enablePydolfin is removed
-      new_lines = []
-      for line in lines:
-        if line.startswith("enablePydolfin"):
-          if not "enablePython" in lines:
-            env["enablePython"] = eval(line.split('=')[1])
-            new_lines.append("enablePython = %s\n" % env["enablePython"])
-        else:
-          new_lines.append(line)
-      if new_lines != lines:
-        file(optsCache, 'w').writelines(new_lines)
     except IOError, msg:
       pass
 
@@ -249,3 +235,19 @@
   elif env["enableDebug"]:
     env.Append(CXXFLAGS=" -DDEBUG -g -O2  -Werror")
   else:
+    # FIXME: why are we optimizing when enableOptimize is False?
+    env.Append(CXXFLAGS=" -O2")
+
+  # Not sure we need this - but lets leave it for completeness sake - if people
+  # use if for PyCC, and know that dolfin use the same system, they will expect
+  # it to be here. We should probably discuss whether that is a good argument or
+  # not.
+  # Append whatever custom flags given
+  if env["customCxxFlags"]:
+    env.Append(CXXFLAGS=" " + env["customCxxFlags"])
+
+  # Append custom linker flags
+  if env["customLinkFlags"]:
+    env.Append(LINKFLAGS=" " + env["customLinkFlags"])
+
+  # Determine which compiler to be used:

=== doc/manual/Makefile ===
FILENAME='dolfin-user-manual'

all:
	latex $(FILENAME).tex

final:
	latex $(FILENAME).tex
	bibtex $(FILENAME)
	latex $(FILENAME).tex
	makeindex $(FILENAME)
	latex $(FILENAME)
	dvips -P pdf -o $(FILENAME).ps $(FILENAME).dvi
	ps2pdf $(FILENAME).ps $(FILENAME).pdf

=== bench/common/progress/cpp/SConstruct ===
import os, commands

# Get compiler from pkg-config
compiler = commands.getoutput('pkg-config --variable=compiler dolfin')

# Create a SCons Environment based on the main os environment
env = Environment(ENV=os.environ, CXX=compiler)

# Get compiler flags from pkg-config
env.ParseConfig('pkg-config --cflags --libs dolfin')

# Program name
env.Program('bench', 'main.cpp')

=== bench/fem/assembly/cpp/SConstruct ===
# This is an example of a simple SConstruct file for building
# programs against DOLFIN. To build this demo, just type 'scons'.

import os, commands

# Get compiler from pkg-config
compiler = commands.getoutput('pkg-config --variable=compiler dolfin')

# Create a SCons Environment based on the main os environment
env = Environment(ENV=os.environ, CXX=compiler)

# Get compiler flags from pkg-config
env.ParseConfig('pkg-config --cflags --libs dolfin')

# Program name
env.Program('bench', 'main.cpp')

=== bench/fem/speedup/cpp/SConstruct ===
# This is an example of a simple SConstruct file for building
# programs against DOLFIN. To build this demo, just type 'scons'.

import os, commands

# Get compiler from pkg-config
compiler = commands.getoutput('pkg-config --variable=compiler dolfin')

# Create a SCons Environment based on the main os environment
env = Environment(ENV=os.environ, CXX=compiler)

# Get compiler flags from pkg-config
env.ParseConfig('pkg-config --cflags --libs dolfin')

# Program names
env.Program('solve-poisson', 'solve-poisson.cpp')
env.Program('assemble-poisson', 'assemble-poisson.cpp')

=== bench/mesh/refinement/cpp/SConstruct ===
import os, commands

# Get compiler from pkg-config
compiler = commands.getoutput('pkg-config --variable=compiler dolfin')

# Create a SCons Environment based on the main os environment
env = Environment(ENV=os.environ, CXX=compiler)

# Get compiler flags from pkg-config
env.ParseConfig('pkg-config --cflags --libs dolfin')

# Program name
env.Program('bench', 'main.cpp')

=== demo/adaptivity/extrapolation/cpp/SConstruct ===
# This is an example of a simple SConstruct file for building
# programs against DOLFIN. To build this demo, just type 'scons'.

import os, commands

# Get compiler from pkg-config
compiler = commands.getoutput('pkg-config --variable=compiler dolfin')

# Create a SCons Environment based on the main os environment
env = Environment(ENV=os.environ, CXX=compiler)

# Get compiler flags from pkg-config
env.ParseConfig('pkg-config --cflags --libs dolfin')

# Program name
env.Program('demo', 'main.cpp')

=== demo/ode/harmonic/cpp/SConstruct ===
# This is an example of a simple SConstruct file for building
# programs against DOLFIN. To build this demo, just type 'scons'.

import os, commands

# Get compiler from pkg-config
compiler = commands.getoutput('pkg-config --variable=compiler dolfin')

# Create a SCons Environment based on the main os environment
env = Environment(ENV=os.environ, CXX=compiler)

# Get compiler flags from pkg-config
env.ParseConfig('pkg-config --cflags --libs dolfin')

# Program name
env.Program('demo', 'main.cpp')
env.Program('demo_solvedual', 'main_solvedual.cpp')

=== demo/pde/cahn-hilliard/cpp/SConstruct ===
# This is an example of a simple SConstruct file for building
# programs against DOLFIN. To build this demo, just type 'scons'.

import os, commands

# Get compiler from pkg-config
compiler = commands.getoutput('pkg-config --variable=compiler dolfin')

# Create a SCons Environment based on the main os environment
env = Environment(ENV=os.environ, CXX=compiler)

# Get compiler flags from pkg-config
env.ParseConfig('pkg-config --cflags --libs dolfin')

# Program name
env.Program('demo', ['main.cpp', 'CahnHilliard2D.cpp', 'CahnHilliard3D.cpp'])

=== demo/pde/elastodynamics/cpp/SConstruct ===
import os, commands

# Get compiler from pkg-config
compiler = commands.getoutput('pkg-config --variable=compiler dolfin')

# Create a SCons Environment based on the main os environment
env = Environment(ENV=os.environ, CXX=compiler)

# Get compiler flags from pkg-config
env.ParseConfig('pkg-config --cflags --libs dolfin')

# Program name
env.Program('demo', ['main.cpp'])

=== demo/pde/dg/advection-diffusion/cpp/SConstruct ===
# This is an example of a simple SConstruct file for building
# programs against DOLFIN. To build this demo, just type 'scons'.

import os, commands

# Get compiler from pkg-config
compiler = commands.getoutput('pkg-config --variable=compiler dolfin')

# Create a SCons Environment based on the main os environment
env = Environment(ENV=os.environ, CXX=compiler)

# Get compiler flags from pkg-config
env.ParseConfig('pkg-config --cflags --libs dolfin')

# Program name
env.Program('demo', 'main.cpp')

=== debian/changelog ===
dolfin (0.9.8-3) unstable; urgency=low

  * Disable Trilinos on non-supported platforms (closes: #590100).

 -- Johannes Ring <johannr@simula.no>  Wed, 04 Aug 2010 16:47:38 +0200

dolfin (0.9.8-2) unstable; urgency=low

  * Fix generation of pkg-config file dolfin.pc.

 -- Johannes Ring <johannr@simula.no>  Sun, 04 Jul 2010 20:41:45 +0200

dolfin (0.9.8-1) unstable; urgency=low

  * New upstream release.
  * debian/control: 
    - Update version for python-ufc in Build-Depends field.
    - Update version for python-ufl in Depends field for binary package
      libdolfin0-dev.
    - Update version for ufc, python-ffc, and python-viper in Depends
      field for binary package libdolfin0-dev.
    - Add libarmadillo-dev to Build-Depends and Depends for binary
      package libdolfin0-dev.
  * Allow building against either version 3.0.0 or 3.1 of PETSc. 
  * Remove patches (added upstream).
  * Switch to dpkg-source 3.0 (quilt) format.
  * Update debian/copyright and debian/copyright_hints.
  * Enable Trilinos support.

 -- Johannes Ring <johannr@simula.no>  Fri, 02 Jul 2010 13:24:21 +0200

dolfin (0.9.7-5) unstable; urgency=low

  * Add patch from upstream to detect and build with SCOTCH.

 -- Johannes Ring <johannr@simula.no>  Mon, 14 Jun 2010 13:15:04 +0200

dolfin (0.9.7-4) unstable; urgency=low

  * Add support for PETSc 3.1 (closes: #583419).
  * Minor fix in Vcs fields in debian/control.

 -- Johannes Ring <johannr@simula.no>  Mon, 07 Jun 2010 09:25:13 +0200

dolfin (0.9.7-3) unstable; urgency=low

  * debian/rules: Remove bashism (closes: #581470).

 -- Johannes Ring <johannr@simula.no>  Thu, 20 May 2010 10:27:06 +0200

dolfin (0.9.7-2) unstable; urgency=low

  * Package moved from pkg-scicomp to Debian Science.
  * Enable building for multiple Python versions.
  * debian/control:
    - Replace python-dev with python-all-dev in Build-Depends.
    - Update version dependencies for python-ufc, ufc, python-ffc, and
      python-viper (closes: #571780).
    - Replace libscotch-dev with libptscotch-dev in Build-Depends and in
      Depends for binary package libdolfin0-dev.
  * Add configure target to cdbs tweaks for scons.
  * Rename binary package python-pydolfin0 to python-dolfin.

 -- Johannes Ring <johannr@simula.no>  Tue, 27 Apr 2010 17:21:22 +0200

dolfin (0.9.7-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Add pkg-config to Build-Depends and Depends in
    binary package libdolfin0-dev.
  * Do not build with GTS (support was removed upstream).
  * Keep debian/copyright and debian/copyright_hints up to date.

 -- Johannes Ring <johannr@simula.no>  Thu, 18 Feb 2010 00:40:38 +0100

dolfin (0.9.6-2) unstable; urgency=low

  * Disable support for Trilinos for now.

 -- Johannes Ring <johannr@simula.no>  Sat, 13 Feb 2010 09:55:48 +0100

dolfin (0.9.6-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    - Add libtrilinos-dev to Build-Depends and Depends for binary
      package libdolfin0-dev.
    - Add python-pytrilinos to Build-Depends and Depends for binary
      package python-pydolfin0.
    - Bump Standards-Version to 3.8.4 (no changes needed).
  * debian/rules:
    - Enable building with Trilinos.
    - Remove some old lintian fixes.
    - Fix problem when generating pkg-config dolfin.pc in
      install/libdolfin0-dev target.
  * debian/copyright: Keep up-to-date with new and removed files.

 -- Johannes Ring <johannr@simula.no>  Fri, 12 Feb 2010 10:27:02 +0100

dolfin (0.9.5-1) unstable; urgency=low

  * New upstream release. This release simplifies the use of Constants
    and Expressions in both the C++ and Python interfaces, with the
    automatic selection of function spaces from Python. Support for
    computing eigenvalues of symmetric matrices has been improved and a
    number of small bugs have been fixed.
  * debian/watch: Update download URL.
  * debian/copyright: Update for new and removed files.
  * debian/rules: 
    - Include new adaptivity demos in dolfin-doc package.
    - Disable ParMETIS and MTL4 explicitly.
  * Add debian/dolfin-doc.doc-base for DOLFIN user manual.
  * debian/control: Slight modifications in package descriptions.
  * debian/python-pydolfin0.install: Allow both site-packages and
    dist-packages.

 -- Johannes Ring <johannr@simula.no>  Thu, 10 Dec 2009 11:53:04 +0100

dolfin (0.9.4-1) unstable; urgency=low

  * New upstream release. This version cleans up the design of the
    function class by adding a new abstraction for user-defined
    functions called Expression. A number of minor bugfixes and
    improvements have also been made.
  * debian/watch: Update for new flat directory structure.
  * Update debian/copyright.
  * debian/rules: Use explicit paths to PETSc 3.0.0 and SLEPc 3.0.0.

 -- Johannes Ring <johannr@simula.no>  Mon, 12 Oct 2009 14:13:18 +0200

dolfin (0.9.3-1) unstable; urgency=low

  * New upstream release. This version provides many new features,
    improvements and bug fixes, including improved XML file handling,
    improved Python support and compressed VTK file output. Experimental
    parallel assembly and solve is now available, with fully distributed
    meshes, parallel mesh partitioning and parallel IO.
  * debian/control:
    - Add DM-Upload-Allowed: yes.
    - Bump debhelper version to 7.
    - Bump Standards-Version to 3.8.3 (no changes needed).
    - Add libboost-program-options-dev and libboost-filesystem-dev to
      Build-Depends and to Depends for binary package libdolfin0-dev.
  * debian/rules:
    - Update for new 3 step build process.
    - Build documentation.
  * Update debian/copyright.
  * Remove old patches (now included upstream).
  * Remove (temporary) support for Trilinos because of #529807.

 -- Johannes Ring <johannr@simula.no>  Mon, 28 Sep 2009 09:21:05 +0200

dolfin (0.9.2-2) unstable; urgency=low

  * debian/control: 
    - add build-dependency on libtrilinos-dev and
      libboost-serialization-dev (closes: #540118). 


=== debian/control ===
Source: dolfin
Section: math
Priority: extra
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>, Johannes Ring <johannr@simula.no>
Build-Depends: cdbs (>= 0.4.49), debhelper (>= 7), python-all-dev, 
 python-central (>= 0.5.6), scons, swig (>= 1.3.35), python-numpy, pkg-config,
 libxml2-dev, libboost-dev, libboost-serialization-dev, libsuitesparse-dev,
 python-ufc (>= 1.4.1), libptscotch-dev, libpetsc3.1-dev | libpetsc3.0.0-dev,
 libslepc3.0.0-dev (>= 3.0.0-p7.dfsg-7), libarmadillo-dev,
 libboost-filesystem-dev, libboost-program-options-dev,
 libtrilinos-dev[!armel !mips !mipsel !s390 !hppa !hurd-i386],
Build-Depends-Indep: texlive-latex-recommended, texlive-latex-extra, 
 texlive-math-extra, ghostscript
Standards-Version: 3.8.4
XS-Python-Version: >= 2.5
Homepage: http://www.fenics.org/wiki/DOLFIN
DM-Upload-Allowed: yes
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/fenics/dolfin/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/fenics/dolfin/trunk/

Package: libdolfin0-dev
Section: libdevel
Architecture: any
XB-Python-Version: ${python:Versions}
Conflicts: libdolfin-dev
Replaces: libdolfin-dev
Provides: libdolfin-dev
Depends: libdolfin0 (= ${binary:Version}), libxml2-dev, pkg-config,
 libboost-dev, libboost-program-options-dev, libboost-filesystem-dev,
 libboost-serialization-dev, libsuitesparse-dev, python-dev, python-numpy,
 libptscotch-dev, libpetsc3.1-dev | libpetsc3.0.0-dev,
 libslepc3.0.0-dev (>= 3.0.0-p7.dfsg-7), libarmadillo-dev,
 python-ufl (>= 0.5.3-1),
 libtrilinos-dev[!armel !mips !mipsel !s390 !hppa !hurd-i386],
 ${misc:Depends}
Description: Shared links and header files for DOLFIN
 DOLFIN is the C++/Python interface of FEniCS, providing a consistent PSE
 (Problem Solving Environment) for ordinary and partial differential equations.
 .
 This package contains the development files.

Package: dolfin-dev
Section: libdevel
Architecture: all
XB-Python-Version: ${python:Versions}
Depends: libdolfin0-dev, ${misc:Depends}
Description: Empty package depending on latest DOLFIN development package
 DOLFIN is the C++/Python interface of FEniCS, providing a consistent PSE
 (Problem Solving Environment) for ordinary and partial differential equations.
 .
 This package will always depend on the most recent version of libdolfinX-dev
 (X=version), so if you install it then you will get upgrades automatically.

Package: libdolfin0
Section: libs
Architecture: any
Conflicts: libdolfin
Replaces: libdolfin
Provides: libdolfin
Depends: ufc (>= 1.4.1-1), python-ffc (>= 0.9.3-1), python-viper (>= 0.4.6-1),
 ${shlibs:Depends}, ${misc:Depends}
Suggests: dolfin-doc, libdolfin0-dbg, python-dolfin
Description: shared libraries for DOLFIN
 DOLFIN is the C++/Python interface of FEniCS, providing a consistent PSE
 (Problem Solving Environment) for ordinary and partial differential equations.
 .
 This package contains the shared libraries.

Package: libdolfin0-dbg
Section: debug
Architecture: any
XB-Python-Version: ${python:Versions}
Conflicts: libdolfin-dbg
Replaces: libdolfin-dbg
Provides: libdolfin-dbg
Depends: libdolfin0 (= ${binary:Version}), ${misc:Depends}
Description: Shared libraries with debugging symbols for DOLFIN
 DOLFIN is the C++/Python interface of FEniCS, providing a consistent PSE
 (Problem Solving Environment) for ordinary and partial differential equations.
 .
 This package contains the shared libraries with debugging symbols.

Package: python-dolfin
Section: python
Architecture: any
XB-Python-Version: ${python:Versions}
Conflicts: python-pydolfin0
Replaces: python-pydolfin0
Depends: libdolfin0-dev (= ${binary:Version}),
 libdolfin0 (= ${binary:Version}),
 python-pytrilinos[!armel !mips !mipsel !s390 !hppa !hurd-i386],
 ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: python-pydolfin0, ${python:Provides}
Suggests: dolfin-doc
Description: Python interface for DOLFIN
 DOLFIN is the C++/Python interface of FEniCS, providing a consistent PSE
 (Problem Solving Environment) for ordinary and partial differential equations.
 .
 This package contains the Python interface for DOLFIN.

Package: dolfin-doc
Architecture: all
XB-Python-Version: ${python:Versions}
Section: doc
Depends: libdolfin0-dev (>= ${source:Version}),
 python-dolfin (>= ${source:Version}), ${misc:Depends}
Suggests: scons
Description: Documentation and demo programs for DOLFIN
 DOLFIN is the C++/Python interface of FEniCS, providing a consistent PSE
 (Problem Solving Environment) for ordinary and partial differential equations.
 .
 This package contains documentation and demo programs for DOLFIN.

Package: dolfin-bin
Architecture: all
XB-Python-Version: ${python:Versions}
Depends: python-dolfin (>= ${source:Version}), ${python:Depends},
 ${misc:Depends}
Description: Executable scripts for DOLFIN
 DOLFIN is the C++/Python interface of FEniCS, providing a consistent PSE
 (Problem Solving Environment) for ordinary and partial differential equations.
 .
 This package contains executable scripts for DOLFIN.

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(DEB_MAINTAINER_MODE))
  # Enable stuff not policy compliant (eg. unsuitable for build daemons)
  DEB_COPYRIGHT_CHECK_STRICT = yes
endif

include debian/cdbs/1/rules/copyright-check.mk
include debian/cdbs/1/class/scons.mk
include /usr/share/cdbs/1/rules/debhelper.mk

# Enable parallel building
ifneq (,$(findstring parallel,$(DEB_BUILD_OPTIONS)))
    PARALLEL_JOBS := $(shell echo $(DEB_BUILD_OPTIONS) | \
        sed -e 's/.*parallel=\([0-9]\+\).*/\1/')
NJOBS := -j$(PARALLEL_JOBS)
endif

DEB_COMPRESS_EXCLUDE := .py .cpp .h .pdf
DEB_INSTALL_DOCS_ALL += AUTHORS README TODO

DEB_DH_INSTALL_SOURCEDIR = debian/tmp

DEB_SCONS_INVOKE = `which scons` --directory="$(DEB_BUILDDIR)"

DEB_SCONS_CONFIGURE_TARGET = configure
DEB_SCONS_CONFIGURE_OPTIONS = \
	prefix=/usr \
	enableMpi=1 \
	enableUmfpack=1 \
	enableTrilinos=1 \
	enablePetsc=1 \
	withPetscDir=/usr/lib/petsc \
	withPetscArch=`petscarch` \
	enableSlepc=1 \
	withSlepcDir=/usr/lib/slepcdir/3.0.0 \
	enableScotch=1 \
	enableDocs=0 \
	enableDemos=0 \
	enableTests=0 \
	enablePython=1 \
	enableParmetis=0 \
	enableMtl4=0 \
	enableCgal=0

DEB_SCONS_BUILD_OPTIONS = $(NJOBS)

DEB_SCONS_INSTALL_OPTIONS = DESTDIR=$(DEB_DESTDIR)

doc_dir = $(CURDIR)/debian/dolfin-doc/usr/share/doc/dolfin-doc

USCAN_DESTDIR := $(CURDIR)

PYVERSIONS = $(shell pyversions --requested debian/control)

clean::
	find dolfin -name "*.os" | xargs rm -f
	find dolfin -name "*.so*" | xargs rm -f
	find scons -name "*.pyc" | xargs rm -f
	rm -f .sconf_temp
	rm -f scons/.sconsign.dblite
	rm -f scons/configure.log
	rm -f scons/options.cache
	rm -rf scons/pkgconfig
	rm -f simula_scons.log
	rm -f dolfin.conf
	rm -f doc/manual/dolfin-user-manual.aux
	rm -f doc/manual/dolfin-user-manual.bbl
	rm -f doc/manual/dolfin-user-manual.blg
	rm -f doc/manual/dolfin-user-manual.dvi
	rm -f doc/manual/dolfin-user-manual.idx
	rm -f doc/manual/dolfin-user-manual.ilg
	rm -f doc/manual/dolfin-user-manual.ind
	rm -f doc/manual/dolfin-user-manual.log
	rm -f doc/manual/dolfin-user-manual.out
	rm -f doc/manual/dolfin-user-manual.pdf
	rm -f doc/manual/dolfin-user-manual.ps
	rm -f doc/manual/dolfin-user-manual.toc
	rm -rf $(addprefix install-stamp-, $(PYVERSIONS))

# Re-configure, build, and install for all versions of Python
install/python-dolfin:: $(addprefix install-stamp-, $(PYVERSIONS))
install-stamp-%:
	rm -f scons/pkgconfig/python*.pc
	rm -f scons/pkgconfig/numpy*.pc
	`which $*` $(DEB_SCONS_INVOKE) $(DEB_SCONS_CONFIGURE_TARGET) \
	  $(DEB_SCONS_CONFIGURE_OPTIONS)
	`which $*` $(DEB_SCONS_INVOKE) $(DEB_SCONS_BUILD_OPTIONS)
	`which $*` $(DEB_SCONS_INVOKE) $(DEB_SCONS_INSTALL_TARGET) \
	  $(DEB_SCONS_INSTALL_OPTIONS)

# Generate pkg-config file for DOLFIN based on pkg-config files 
# in scons/pkgconfig:
	cd $(DEB_DESTDIR)/usr/lib/pkgconfig && \
	for req in `grep "^Requires:" dolfin.pc | cut -d':' -f2 | tac -s ' '`; \
	do \
	  if [ -e $$req.pc ]; \
	  then \
	    sed -i "/^Libs/s|$$|`PKG_CONFIG_PATH=$$PWD pkg-config $$req --libs` |" dolfin.pc; \
	    sed -i "/^Cflags/s|$$|`PKG_CONFIG_PATH=$$PWD pkg-config $$req --cflags` |" dolfin.pc; \
	    sed -i "/^Requires:/s/$$req/ /g" dolfin.pc; \
	  fi; \
	done

	touch $@

install/dolfin-doc::
	mkdir -p $(doc_dir)/demo
	mkdir -p $(doc_dir)/data
	cp -a demo/adaptivity $(doc_dir)/demo
	cp -a demo/fem $(doc_dir)/demo
	cp -a demo/function $(doc_dir)/demo
	cp -a demo/la $(doc_dir)/demo
	cp -a demo/mesh $(doc_dir)/demo
	cp -a demo/ode $(doc_dir)/demo
	cp -a demo/parameters $(doc_dir)/demo
	cp -a demo/pde $(doc_dir)/demo
	cp -a demo/plot $(doc_dir)/demo
	cp -a demo/quadrature $(doc_dir)/demo
	cp -a data/graphs $(doc_dir)/data
	cp -a data/meshes $(doc_dir)/data
# Generate and install the documentation pdf:
	cd doc/manual && make final
	cp doc/manual/dolfin-user-manual.pdf $(doc_dir)

binary-install/python-dolfin::
	dh_pycentral -p$(cdbs_curpkg)

binary-install/dolfin-bin::
	dh_pycentral -p$(cdbs_curpkg)

get-orig-source:
	uscan --force-download --verbose --destdir $(USCAN_DESTDIR) \
	 --download-version $(DEB_UPSTREAM_VERSION) \
	 --upstream-version $(DEB_UPSTREAM_VERSION)

=== debian/watch ===
version=3
http://launchpad.net/dolfin/+download http://launchpad.net/dolfin/.*/dolfin-(.*)\.tar\.gz
